%% Author: Helmer Aaviksoo & Karli Kirsime
-module(pingpong).
-export([start/1, ping/2, pong/0]).

ping(0, Pong_PID) ->
    Pong_PID ! finished,
    io:format("Ping finished~n", []);

ping(N, Pong_PID) ->
    timer:sleep(1000),
    Pong_PID ! {ping, self()},
    receive
        pong ->
            io:format("Ping received pong~n", [])
    end,
    ping(N - 1, Pong_PID).

pong() ->
    receive
        finished ->
            io:format("Pong finished~n", []);
        {ping, Ping_PID} ->
            io:format("Pong received ping~n", []),
            timer:sleep(1000),
            Ping_PID ! pong,
            pong()
    end.

start(X) ->
    Pong_PID = spawn(pingpong, pong, []),
    spawn(pingpong, ping, [X, Pong_PID]).